﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace geometryProcess
{
    public partial class Form1 : Form
    {

        Bitmap img, img1;
        int nRed, nGreen, nBlue, dX, dY, nX, nY,cX,cY, x, y;
        Color pixelColor;
        double[] m = new double[100];
        int[] pixR = new int[10];
        int[] pixG = new int[10];
        int[] pixB = new int[10];

        public Form1()
        {
            InitializeComponent();
        }

        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {
            OpenFileDialog oFile = new OpenFileDialog();
            if (oFile.ShowDialog() == DialogResult.OK)
            {
                img = new Bitmap(new Bitmap(oFile.FileName), pictureBox1.Width, pictureBox1.Height);
                pictureBox1.Image = img;
            }
        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog objek = new SaveFileDialog();
            objek.Filter = "JPEG File (*.jpeg)|*.jpeg|Gif File (*.gif)|*.gif|Bitmap File (*.bmp)|*.bmp";
            objek.Title = "Save an Image File";
            if (objek.ShowDialog() == DialogResult.OK)
            {
                if (objek.FileName != "")
                {
                    System.IO.FileStream fs = (System.IO.FileStream)objek.OpenFile();
                    switch (objek.FilterIndex)
                    {
                        case 1:
                            this.pictureBox2.Image.Save(fs, System.Drawing.Imaging.ImageFormat.Jpeg);
                            break;

                        case 2:
                            this.pictureBox2.Image.Save(fs, System.Drawing.Imaging.ImageFormat.Gif);
                            break;

                        case 3:
                            this.pictureBox2.Image.Save(fs, System.Drawing.Imaging.ImageFormat.Bmp);
                            break;
                    }

                    fs.Close();
                }
            }
        }

        private void exiToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void zoomInToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Deklarasi citra baru berdasarkan 2 kali ukuran citra awal
            img1 = new Bitmap(img.Width * 2, img.Height * 2);
            //Struktur bersarang untuk meload semua pixel berdasarkan citra awal
            for (x = 0; x < img.Width; x++)
            {
                for (y = 0; y < img.Height; y++)
                {
                    pixelColor = img.GetPixel(x, y);
                    //Menyimpan pixel baru untuk citra yang baru
                    img1.SetPixel(2 * x, 2 * y, pixelColor);
                    img1.SetPixel((2 * x) + 1, 2 * y, pixelColor);
                    img1.SetPixel(2 * x, (2 * y) + 1, pixelColor);
                    img1.SetPixel((2 * x) + 1, (2 * y) + 1, pixelColor);
                }
            }
            //Menyimpan citra baru pada pictureBox2
            pictureBox2.Image = img1;
        }

        private void zoomOutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            img1 = new Bitmap((img.Width) / 3, (img.Height) / 3);
            double widthNew = (img.Width - 3) / 3, heightNew = (img.Height - 3) / 3;
            for (x = 0; x <= Convert.ToInt32(Math.Round(widthNew)); x++)
            {
                for (y = 0; y <= Convert.ToInt32(Math.Round(heightNew)); y++)
                {
                    pixelColor = img.GetPixel((x * 3), (y * 3));
                    pixR[0] = pixelColor.R;
                    pixG[0] = pixelColor.G;
                    pixB[0] = pixelColor.B;

                    pixelColor = img.GetPixel((x * 3) + 1, (y * 3));
                    pixR[1] = pixelColor.R;
                    pixG[1] = pixelColor.G;
                    pixB[1] = pixelColor.B;

                    pixelColor = img.GetPixel((x * 3) + 2, (y * 3));
                    pixR[2] = pixelColor.R;
                    pixG[2] = pixelColor.G;
                    pixB[2] = pixelColor.B;

                    pixelColor = img.GetPixel((x * 3), (y * 3) + 1);
                    pixR[3] = pixelColor.R;
                    pixG[3] = pixelColor.G;
                    pixB[3] = pixelColor.B;

                    pixelColor = img.GetPixel((x * 3) + 1, (y * 3) + 1);
                    pixR[4] = pixelColor.R;
                    pixG[4] = pixelColor.G;
                    pixB[4] = pixelColor.B;

                    pixelColor = img.GetPixel((x * 3) + 2, (y * 3) + 1);
                    pixR[5] = pixelColor.R;
                    pixG[5] = pixelColor.G;
                    pixB[5] = pixelColor.B;

                    pixelColor = img.GetPixel((x * 3), (y * 3) + 2);
                    pixR[6] = pixelColor.R;
                    pixG[6] = pixelColor.G;
                    pixB[6] = pixelColor.B;

                    pixelColor = img.GetPixel((x * 3) + 1, (y * 3) + 2);
                    pixR[7] = pixelColor.R;
                    pixG[7] = pixelColor.G;
                    pixB[7] = pixelColor.B;

                    pixelColor = img.GetPixel((x * 3) + 2, (y * 3) + 2);
                    pixR[8] = pixelColor.R;
                    pixG[8] = pixelColor.G;
                    pixB[8] = pixelColor.B;

                    nRed = Convert.ToInt32((pixR[0] + pixR[1] + pixR[2] + pixR[3] + pixR[4] + pixR[5] + pixR[6] + pixR[7] + pixR[8]) / 9);
                    nGreen = Convert.ToInt32((pixG[0] + pixG[1] + pixG[2] + pixG[3] + pixG[4] + pixG[5] + pixG[6] + pixG[7] + pixG[8]) / 9);
                    nBlue = Convert.ToInt32((pixB[0] + pixB[1] + pixB[2] + pixB[3] + pixB[4] + pixB[5] + pixB[6] + pixB[7] + pixB[8]) / 9);

                    if (nRed > 255)
                        nRed = 255;
                    else if (nRed < 0)
                        nRed = 0;
                    if (nGreen > 255)
                        nGreen = 255;
                    else if (nGreen < 0)
                        nGreen = 0;
                    if (nBlue > 255)
                        nBlue = 255;
                    else if (nBlue < 0)
                        nBlue = 0;
                    Color newPixelColor = Color.FromArgb(nRed, nGreen, nBlue);
                    img1.SetPixel(x, y, newPixelColor);
                }
            }
            pictureBox2.Image = img1;
        }

        private void toolStripMenuItem2_Click(object sender, EventArgs e)
        {
            //Deklarasi citra baru berdasarkan  ukuran citra awal 
            img1 = new Bitmap(img.Height, img.Width);
            //Struktur bersarang untuk meload semua pixel berdasarkan citra awal
            for (int x = 0; x < img.Width; x++)
            {
                for (int y = 0; y < img.Height; y++)
                {
                    pixelColor = img.GetPixel(x, y);
                    //Menyimpan pixel baru untuk citra yang baru
                    img1.SetPixel(img1.Width - 1 - y, x, pixelColor);
                }
            }
            pictureBox2.Image = img1;   //Menyimpan citra baru di pictureBox2
        }

        private void toolStripMenuItem3_Click(object sender, EventArgs e)
        {
            //Deklarasi citra baru berdasarkan  ukuran citra awal 
            img1 = new Bitmap(img.Width, img.Height);
            //Struktur bersarang untuk meload semua pixel berdasarkan citra awal
            for (int x = 0; x < img.Width; x++)
            {
                for (int y = 0; y < img.Height; y++)
                {
                    pixelColor = img.GetPixel(x, y);
                    //Menyimpan pixel baru untuk citra yang baru
                    img1.SetPixel(img1.Width - 1 - x, img1.Height - 1 - y, pixelColor);
                }
            }
            pictureBox2.Image = img1; ;  //Menyimpan citra baru di pictureBox2
        }

        private void toolStripMenuItem4_Click(object sender, EventArgs e)
        {
            //Deklarasi citra baru berdasarkan  ukuran citra awal 
            img1 = new Bitmap(img.Height, img.Width);
            //Struktur bersarang untuk meload semua pixel berdasarkan citra awal
            for (int x = 0; x < img.Width; x++)
            {
                for (int y = 0; y < img.Height; y++)
                {
                    pixelColor = img.GetPixel(x, y);
                    //Menyimpan pixel baru untuk citra yang baru
                    img1.SetPixel(y, img1.Height - 1 - x, pixelColor);
                }
            }
            pictureBox2.Image = img1;  //Menyimpan citra baru di pictureBox2
        }

        private void translasiToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Form2 f2 = new Form2(); // Deklarasi form2 dengan f2 
            //Deklarasi citra baru berdasarkan  ukuran citra awal 
            img1 = new Bitmap(img.Width, img.Height);  
            if (f2.ShowDialog() == DialogResult.OK)
            {
                dX = Convert.ToInt32(f2.textBox1.Text);
                dY = Convert.ToInt32(f2.textBox2.Text);
                //Struktur bersarang untuk meload semua pixel berdasarkan citra awal
                for (int x = 0; x < img.Width; x++)
                {
                    for (int y = 0; y < img.Height; y++)
                    {
                        if (((x + dX) >= 0) && ((x + dX) < img.Width) && ((y + dY) >= 0) && ((y + dY) < img.Height))
                        {
                            pixelColor = img.GetPixel(x, y);
                            nX = x + dX;
                            nY = y + dY;
                            //Menyimpan pixel baru untuk citra yang baru
                            img1.SetPixel(nX, nY, pixelColor);
                        }
                    }
                }
                pictureBox2.Image = img1; //Menyimpan citra baru di pictureBox2
            }
        }

        private void horizontalToolStripMenuItem_Click(object sender, EventArgs e)
        {
           //Deklarasi citra baru berdasarkan  ukuran citra awal
            img1 = new Bitmap(img.Width, img.Height);
           //Struktur bersarang untuk meload semua pixel berdasarkan citra awal
            for (x = 0; x < img.Width; x++)
            {
                for (y = 0; y < img.Height; y++)
                {
                    //Mendapatkan data pixel pada area form
                    pixelColor = img.GetPixel(x, y);
                    //Menyimpan pixel baru untuk citra yang baru
                    img1.SetPixel(img.Width - 1 - x, y, pixelColor);
                }
            }
            pictureBox2.Image = img1; //Menyimpan citra baru di pictureBox2
        }

        private void vertikalToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Deklarasi citra baru berdasarkan  ukuran citra awal
            img1 = new Bitmap(img.Width, img.Height);
            //Struktur bersarang untuk meload semua pixel berdasarkan citra awal
            for (x = 0; x < img.Width; x++)
            {
                for (y = 0; y < img.Height; y++)
                {
                    //Mendapatkan data pixel pada area form
                    pixelColor = img.GetPixel(x, y);
                    //Menyimpan pixel baru untuk citra yang baru
                    img1.SetPixel(x, img.Height - 1 - y, pixelColor);
                }
            }
            pictureBox2.Image = img1;  //Menyimpan citra baru di pictureBox2
        }

        private void pictureBox1_MouseMove(object sender, MouseEventArgs e)
        {
            if (img != null)
            {
                cX = e.X;
                cY = e.Y;

                Color pixelColor = img.GetPixel(cX, cY);
                nRed = pixelColor.R;
                nGreen = pixelColor.G;
                nBlue = pixelColor.B;
                label2.Text = "[X,Y] : " + cX.ToString() + "," + cY.ToString() + "  R,G,B : " + nRed.ToString() + "," + nGreen.ToString() + "," + nBlue.ToString();
            }
        }

        private void pictureBox2_MouseMove(object sender, MouseEventArgs e)
        {
            if (img1 != null)
            {
                cX = e.X;
                cY = e.Y;

                Color pixelColor = img1.GetPixel(cX, cY);
                nRed = pixelColor.R;
                nGreen = pixelColor.G;
                nBlue = pixelColor.B;
                label3.Text = "[X,Y] : " + cX.ToString() + "," + cY.ToString() + "  R,G,B : " + nRed.ToString() + "," + nGreen.ToString() + "," + nBlue.ToString();
            }
        }

        private void label3_Click(object sender, EventArgs e)
        {

        }
       }
}
